#ifndef LINK_H
#define LINK_H

#ifdef WIN32
#define NOMINMAX
#include <Windows.h>
#endif

#include <GL/glut.h>
#include <vector>
#include "color.h"
#include "Eigen/Dense"

using namespace Eigen;

class Link
{
public:
  
    Link(Color c)
    {
        mObj = gluNewQuadric();
        gluQuadricDrawStyle(mObj, GLU_FILL);
        gluQuadricOrientation(mObj, GLU_OUTSIDE);
        gluQuadricNormals(mObj, GLU_SMOOTH);
	
	mColor = c;
    }
    
    float mLength;
    float mAngle;
    Vector3f mAxis;
    Matrix3f mRotation;
    GLUquadricObj *mObj;
    Color mColor;
    void setRotation(Vector3f axis, float angle)
    {
        mAxis = axis;
        mAngle = angle;
        makeRodriguesRotationMatrix(mAngle*mAxis, mRotation);
    }
};

#endif // LINK_H
