#include "linkedstructure.h"
#include <cmath>
#include <iostream>
#include "link.h"

#define degrees(x) x*180/3.1415926


MatrixXf LinkedStructure::pseudoInverse()
{
    //compute and return the pseudo inverse of the jacobian matrix
}

void LinkedStructure::calculatePosition()
{
    //compute the global position of the end effector by using the joints configuration (forward kinematics)
}

MatrixXf LinkedStructure::jacobian()
{
    //compute and return the jacobian matrix (de/dangles)

    return J;
}


void LinkedStructure::moveToPoint(const VectorXf position)
{
  // Here we specify the new position we want to move to
  // and set the update flag to true
  mTargetPosition = position;
  mResolveTarget = true;
}

void LinkedStructure::draw()
{
    // Drawing the linke structure on the scren
    glPushMatrix();
    glTranslatef(mBasePosition(0),mBasePosition(1),mBasePosition(2));
    glutSolidSphere(2.0f, 20, 20);

    // going through each link and at the tip of each link
    // We draw a sphere
    for (int i = 0; i < mList.size(); i++)
    {
        float angle;
        Vector3f axis;
        angle = mList[i]->mAngle;
        axis = mList[i]->mAxis;

        glRotatef(degrees(angle), axis(0), axis(1), axis(2));
		mList[i]->mColor.apply();
        gluCylinder(mList[i]->mObj, 1, 1, mList[i]->mLength, 20, 20);
        glTranslatef(0, 0, mList[i]->mLength);
		Color c = { 1.0, 0, 0};
		c.apply();
	// Draw the sphere to show the joint position
        glutSolidSphere(1.5, 20, 20);
    }

    glPopMatrix();
}

void LinkedStructure::moveBy(float dx, float dy, float dz)
{
  // Here we move by dx an dy the linked structure's tip (apply inverse kinematics to calculate the dAngles, update each joint, and then apply forward kinematics)
   
}

void LinkedStructure::update()
{
  // Performs an update to the position of the
  // linked structure. Performs a tip move by the
  // step that has been specified
    calculatePosition();
  if(isTargetResolved())
  {
      return;
  }

 /*
 Here we calculate the step that we want the end effector to take (it has to be in the direction towards the target, but not too big)
 */
  
  moveBy(x, y);
}

bool LinkedStructure::isTargetResolved()
{
  // Checks if at the current position of the linked
  // structure the point we are trying to resolve
  // gets resolved, it's the stop condition for the iterative algorithm
  if(/**/)
  {
      mResolveTarget = false;
      return true;
  }
   
  return false;
}

VectorXf LinkedStructure::getPointWithinRange()
{
  // Returning a random point within the range that the linkedstructure
  // can reach. This method is just for demo purposes. The generated points are on the ZY plane
   VectorXf point = VectorXf::Zero(3, 1);
   float length = 0;
   for(int i = 0; i < mList.size(); i++)
   {
     length += mList[i]->mLength;
   }
   
   point(1) = ((rand() % 2 == 0) ? -1 : 1) * (rand() % (int)(length*0.7));
   point(2) = ((rand() % 2 == 0) ? -1 : 1) * (rand() % (int)(length*0.7));

   return point;
}
